(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'antd', 'react-text-mask', 'classnames', 'moment'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('antd'), require('react-text-mask'), require('classnames'), require('moment'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.antd, global.reactTextMask, global.classnames, global.moment);
        global.DatePicker = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _antd, _reactTextMask, _classnames, _moment) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _reactTextMask2 = _interopRequireDefault(_reactTextMask);

    var _classnames2 = _interopRequireDefault(_classnames);

    var _moment2 = _interopRequireDefault(_moment);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var getPickerValue = function getPickerValue(value, format) {
        return (0, _moment2.default)(value, format).isValid() ? (0, _moment2.default)(value, format) : null;
    };

    var defaultDateMask = [/[0-3]/, /[0-9]/, '.', /[0-1]/, /[0-9]/, '.', /[1-2]/, /[0-9]/, /[0-9]/, /[0-9]/];
    var defaultFormat = 'DD.MM.YYYY';

    var DatepickerComponent = function (_Component) {
        _inherits(DatepickerComponent, _Component);

        function DatepickerComponent(props) {
            _classCallCheck(this, DatepickerComponent);

            var _this = _possibleConstructorReturn(this, (DatepickerComponent.__proto__ || Object.getPrototypeOf(DatepickerComponent)).call(this, props));

            _this.state = {
                guide: false
            };

            _this.onChangeDatepicker = function (moment, value) {
                _this.setValue(value);
            };

            _this.clearInput = function () {
                _this.setValue(null);
            };

            _this.setValue = function (value) {
                _this.props.input.onChange(value);
            };

            _this.container = _react2.default.createRef();
            return _this;
        }

        _createClass(DatepickerComponent, [{
            key: 'componentDidUpdate',
            value: function componentDidUpdate() {
                if (this.props.input.value) {
                    !this.state.guide && this.setState({ guide: true });
                } else {
                    this.state.guide && this.setState({ guide: false });
                }
            }
        }, {
            key: 'render',
            value: function render() {
                var _this2 = this;

                var _props = this.props,
                    input = _props.input,
                    type = _props.type,
                    placeholder = _props.placeholder,
                    mask = _props.mask,
                    disabled = _props.disabled,
                    inputClassName = _props.inputClassName,
                    pickerClassName = _props.pickerClassName,
                    allowClear = _props.allowClear;

                var format = this.props.format || defaultFormat;

                return _react2.default.createElement(
                    'div',
                    { className: 'date-picker' },
                    _react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)({ 'date-input-filled': input.value, 'disabled-input': disabled }) },
                        _react2.default.createElement(
                            'div',
                            null,
                            _react2.default.createElement(_reactTextMask2.default, _extends({}, input, {
                                type: type,
                                disabled: disabled,
                                onChange: this.setValue,
                                className: (0, _classnames2.default)('ant-input', 'date-masked-input', inputClassName),
                                mask: mask || defaultDateMask,
                                placeholder: placeholder,
                                placeholderChar: '\u2000',
                                keepCharPositions: false,
                                guide: this.state.guide
                            })),
                            allowClear && _react2.default.createElement('span', { className: 'ant-select-selection__clear date-input-clear', onClick: this.clearInput })
                        ),
                        _react2.default.createElement(
                            'div',
                            { ref: this.container, className: 'date-calendar' },
                            _react2.default.createElement(_antd.DatePicker, _extends({}, input, this.props, {
                                getCalendarContainer: function getCalendarContainer() {
                                    return _this2.container.current;
                                },
                                className: (0, _classnames2.default)(pickerClassName, { 'disabled-picker': disabled }),
                                value: getPickerValue(input.value, format),
                                onChange: this.onChangeDatepicker,
                                format: format
                            }))
                        )
                    )
                );
            }
        }]);

        return DatepickerComponent;
    }(_react.Component);

    DatepickerComponent.propTypes = {
        input: _propTypes2.default.object.isRequired,
        format: _propTypes2.default.string,
        placeholder: _propTypes2.default.string,
        disabled: _propTypes2.default.bool,
        inputClassName: _propTypes2.default.string,
        pickerClassName: _propTypes2.default.string,
        type: _propTypes2.default.string,
        allowClear: _propTypes2.default.bool
    };
    exports.default = DatepickerComponent;
});